<HTML>
<HEAD>

<META HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<TITLE>dsmobjrun</TITLE>

<!-- 
	University of Illinois/NCSA Open Source License for dsmobjrun.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
*/
-->

</HEAD>
<BODY>
<?php 
// get the post details from the previous...

// newer systems support the _post system for posted variable
// olderones http_post_vars so we test for both...
if (@$_POST['ldap_id'] > "" ) {
	$working_ou=$_POST['working_ou'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$cn_to_change="cn=" . $_POST['cn_to_change'];
	$attr_to_change=$_POST['attr_to_change'];
	$new_attr_value=$_POST['new_attr_value'];
	$append_context=$_POST['append_context'];
	$new_attr_value_suffix=$_POST['new_attr_value_suffix'];
	
} else {

	if (@$HTTP_POST_VARS['ldap_id'] > "" ) {
		$working_ou=$HTTP_POST_VARS['working_ou'];
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$cn_to_change="cn=" . $HTTP_POST_VARS['cn_to_change'];
		$attr_to_change=$HTTP_POST_VARS['attr_to_change'];
		$new_attr_value=$HTTP_POST_VARS['new_attr_value'];
		$append_context=$HTTP_POST_VARS['append_context'];
		$new_attr_value_suffix=$HTTP_POST_VARS['new_attr_value_suffix'];
	
	} else {
		echo " <h2>DSmobjrun.php must be run from dsmobjedit.php</h2>\n";
		echo "<p>Please select <a href=\"dsmobjedit.php\"> this link to run the DS multiple object editing system.</p>";
		exit;
	}
}

echo "<h1>DS Multiple Edit Sanity Check</h1>";
echo "<p>Connection to LDAP server";

// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection

$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded<br />";
	// we have now made an LDAP connection
} else { 
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	exit;
}

// now we are in LDAP we need to find every instance of the object
// and display them so the user can check they're not about to do
// something they'll regret!!

// Search for the  entry.
$sr = ldap_search($ds, $working_ou, $cn_to_change, array(cn, $attr_to_change));

echo "<p>Searching in ". $working_ou." for objects named ". $cn_to_change . "</p>";
// Count the number of entries returned and check for errors.

// echo "<p>Search completed, ";

$entry_count = ldap_count_entries($ds, $sr);

// echo $entry_count . " objects found.<br />\n</p>";

// Here we page through all those entries

if($entry_count >0) {
	
	echo "The following " . $entry_count;
	echo " object(s) were found that match " . $cn_to_change;
	echo " under " . $working_ou;
	echo ".</p>\n";

	// get vaulues
	$entry_info=ldap_get_entries($ds, $sr);
	
	// and display them in a table
	
	echo "<TABLE class=\"main\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"1\">";
	echo "<TR>\n<TH>Object DN</TH><TH>Current Value</TH>\n</TR>\n";
	
	foreach ($entry_info as $entry_data) {
		if (strlen($entry_data["dn"])>0) {
				echo "<TR>\n     <TD class=\"maintdpos\">"; 
				echo $entry_data["dn"] . "</TD>\n      <TD class=\"maintdpos\">";
				echo    $entry_data[strtolower($attr_to_change)][0] . "</TD>\n</TR>\n";
				
				// note how the attribute name must be converted to lower case
				// this is a php special, for reasons that escape me that attr name when used as an
				// array index is converted to lower case!!
				// strange, as normally attr names are case sensitive...
		}
	}
	echo "</TABLE>\n";
			//continue;
} else {
	// if no match found...
	echo $attr_to_change ;
	echo "No objects were found that match " . $cn_to_change;
	echo " under " . $working_ou ;
	echo ".<br />\n";
}

// so now the dread warnings...
echo "<h2>If you take the next Step all the above objects will be changed</h2>\n";
echo "<p>Attribute \"" .  	$attr_to_change . "\" will be set to \"" . 	$new_attr_value;

// this is to do with handling attributes that need the OU of
// the object embedded in them (see calling page comments)

if ($append_context == "yes") {
	echo "\",[context]" . $new_attr_value_suffix;
}

echo  "\".</p>\n";

// we'e serious about these warnings!

echo "<h3>Check Details and re-enter the password.</h3>\n";
echo "<h4>This could be very destructive: make sure you know exactly what you are doing!</h4>\n";
echo "<FORM METHOD=\"POST\" ACTION=\"dsmobjchange.php\" ENCTYPE=\"x-www-form-urlencoded\">\n";
echo "<TABLE class=\"main\" CELLPADDING=\"2\" CELLSPACING=\"2\">";
echo "<TR>\n     <TD class=\"maintdpos\">LDAP Admin User ID: </TD>\n"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"ldap_id\" VALUE=\"" . $ldap_id . "\" SIZE=\"30\" MAXLENGTH=\"80\">" . $ldap_id . "</TD>\n"; 
echo "</TR>\n<TR>\n     <TD  class=\"maintdpos\">LDAP Password:</TD>"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"password\" NAME=\"ldap_pw\" SIZE=\"30\" MAXLENGTH=\"40\"></TD>\n"; 
echo "</TR>\n<TR>\n    <TD  class=\"maintdpos\">LDAP Server:</TD>";
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"ldap_server\" VALUE=\"" . $ldap_server . "\" SIZE=\"30\" MAXLENGTH=\"40\">" . $ldap_server . "</TD>\n"; 
echo "</TR>\n<TR>\n     <TD colspan=\"2\">\n	<HR>\n     </TD>\n</TR>\n";
echo "<TR>\n    <TD  class=\"maintdpos\">OU to Change beneath:</TD>\n"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"working_ou\" VALUE=\"" . $working_ou . "\" SIZE=\"30\" MAXLENGTH=\"40\">" . $working_ou . "</TD>\n"; 
echo "</TR>\n<TR>\n    <TD  class=\"maintdpos\">CN Name to Find/Change:</TD>\n"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"cn_to_change\" VALUE=\"" . $cn_to_change . "\" SIZE=\"30\" MAXLENGTH=\"40\">" . $cn_to_change . "</TD>\n"; 
echo "</TR>\n<TR>\n    <TD  class=\"maintdpos\">Attribute to Change:</TD>\n";
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"attr_to_change\" VALUE=\"" . $attr_to_change . "\" SIZE=\"30\" MAXLENGTH=\"40\">" . $attr_to_change . "</TD>\n"; 
echo "</TR>\n<TR>\n    <TD  class=\"maintdpos\">New Attribute value:</TD>\n"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"new_attr_value\" VALUE=\"" . $new_attr_value . "\" SIZE=\"30\" MAXLENGTH=\"100\">" . $new_attr_value . "</TD>\n"; 
echo "</TR>\n<TR>\n    <TD  class=\"maintdpos\">Append Object Context to String?</TD>\n"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"append_context\" VALUE=\"" . $append_context . "\" SIZE=\"30\" MAXLENGTH=\"40\">" . $append_context . "</TD>\n"; 
echo "</TR>\n<TR>\n    <TD  class=\"maintdpos\">New Attr value Suffix:</TD>\n"; 
echo "    <TD  class=\"maintdpos\"><INPUT TYPE=\"hidden\" NAME=\"new_attr_value_suffix\" VALUE=\"" . $new_attr_value_suffix . "\" SIZE=\"30\" MAXLENGTH=\"100\">" . $new_attr_value_suffix . "</TD>\n"; 
echo "</TR>\n<TR>\n     <TD colspan=\"2\">\n	<HR>\n     </TD>\n</TR>\n<TR>\n"; 

echo "    <TD class=\"maintdpos\"><INPUT TYPE=\"submit\" VALUE=\"I Agree and Accept Full Responsibility\"></TD>\n"; 
echo "    <TD class=\"maintdpos\"><INPUT TYPE=\"reset\" VALUE=\"Reset password\"></TD>\n"; 
echo "</TR>\n</TABLE>\n";

exit;

?>
</BODY>
</HTML>
