<HTML>
<HEAD>
<META HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<TITLE>dsmobjchange</TITLE>

<!-- 
/*
	University of Illinois/NCSA Open Source License for dsmobjchange.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
*/

-->

</HEAD>
<BODY>
<?php 

if (@$_POST['ldap_id'] > "" ) { 
	$working_ou=$_POST['working_ou'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$cn_to_change= $_POST['cn_to_change'];
	$attr_to_change=$_POST['attr_to_change'];
	$new_attr_value=$_POST['new_attr_value'];
	$append_context=$_POST['append_context'];
	$new_attr_value_suffix=$_POST['new_attr_value_suffix'];
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) { 
		$working_ou=$HTTP_POST_VARS['working_ou'];
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$cn_to_change= $HTTP_POST_VARS['cn_to_change'];
		$attr_to_change=$HTTP_POST_VARS['attr_to_change'];
		$new_attr_value=$HTTP_POST_VARS['new_attr_value'];
		$append_context=$HTTP_POST_VARS['append_context'];
		$new_attr_value_suffix=$HTTP_POST_VARS['new_attr_value_suffix'];
	} else {
		echo " <h2>DSmobjchange.php must be run from dsmobjbedit.php</h2>\n";
		echo "<p>Please select <a href=\"dsmobjedit.php\"> this link to run the DS multiple object editing system.</p>";
		exit;
	}
}
// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection

// So we start by connecting to LDAP

echo "<h1>DS Multiple Edit Change Log</h1>";
echo "<p>Connection to LDAP server";

$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded<br />";
	// we have now made an LDAP connection
} else { 
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	exit;
}


// now we are in LDAP we ned to
//   find every instance of the object
//   change/set the attribute
// finish...

//do some logging...
$fhandle = fopen("mobjlog.txt", "a");
fwrite($fhandle, $ldap_id . ",");
fwrite($fhandle, ",". 	$working_ou);

fwrite($fhandle, ",". 	$cn_to_change);
fwrite($fhandle, ",". 	$attr_to_change);
fwrite($fhandle, ",". $new_attr_value);
fwrite($fhandle, ",". $append_context);

// Search for the  entry.
$sr = ldap_search($ds, $working_ou, $cn_to_change);

echo "<p>Searching in ". $working_ou." for objects named ". $cn_to_change . "</p>";
// Count the number of entries returned and check for errors.

// echo "<p>Search completed, ";

$entry_count = ldap_count_entries($ds, $sr);

// echo $entry_count . " objects found.<br />\n</p>";
// Here we page through all those entries

if($entry_count >0) {

	echo "The following " . $entry_count;
	echo " object(s) were found that match " . $cn_to_change;
	echo " under " . $working_ou;
	echo ".</p>\n";
	$entry_info=ldap_get_entries($ds, $sr);
	echo "<TABLE class=\"main\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"1\">";
	echo "<TR>\n<TH>Object DN</TH><TH>Previous Value</TH>\n<TH>New Value</TH><TH>Result</TH>\n</TR>\n";
	foreach ($entry_info as $entry_data) {
		if (strlen($entry_data["dn"])>0) {
				echo "<TR>\n     <TD class=\"maintdpos\">"; 
				echo $entry_data["dn"] . "</TD>\n";
				fwrite($fhandle, ",". $entry_data["dn"]);
				// note how the attribute name must be converted to lower case
				// this is a php special, for reasons that escape me that attr name when used as an
				// array index is converted to lower case!!
				// now we're actually making he changes...
				//echo $entry_data["dn"];
				//echo stristr($entry_data["dn"],',');

				$ovalue = $entry_data[strtolower($attr_to_change)][0];

				$mod_string[strtolower($attr_to_change)]=$new_attr_value;	
				if ($append_context == "yes") {
					$mod_string[strtolower($attr_to_change)] .= stristr($entry_data["dn"],',').$new_attr_value_suffix;					
				} 
				if (strlen($ovalue) < 1) {
					$ovalue = "[no value]";
				}
				// make the change...
				if (@ldap_modify($ds,$entry_data["dn"],$mod_string)) {
					// here we're in a test if LDAP modify succeeded
					echo "     <TD class=\"maintdpos\">";
					echo $ovalue . "</TD>\n";
					echo "     <TD class=\"maintdpos\">"; 
					echo $mod_string[strtolower($attr_to_change)];
					echo "     <TD class=\"maintdpos\">succeeded</TD>\n</TR>\n";
					fwrite($fhandle, " succeeeded");
				} else {
					// the change failed...
					echo "     <TD class=\"maintdpos\" COLSPAN=\"3\">";
					echo "edit <b>failed</b>.</TD>\n";
					fwrite($fhandle, " failed");
				}				
			}
		}
	
	echo "</TABLE>\n";
			//continue;
} else {
	echo $attr_to_change ;
	echo "No objects were found that match " . $cn_to_change;
	echo " under " . $working_ou ;
	echo ".<br />\n";
	fwrite($fhandle, ","."No objects changed");
}
fclose($fhandle);
exit;

?>
<p>The changes made have been logged in file mobjlog.txt on the web server.</p>
</BODY>
</HTML>
