<HTML>
<HEAD>
<META HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<TITLE>dsmobjlist</TITLE>

</HEAD>

<!-- 
 
 /*
	University of Illinois/NCSA Open Source License for dsmobjlist.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
*/

-->

<BODY>

<?php 

if (@$_POST['ldap_id'] > "" ) { 
	
	$working_ou=$_POST['working_ou'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$cn_to_change="cn=" . $_POST['cn_to_change'];
	$attr_to_change=$_POST['attr_to_change'];
	$new_attr_value=$_POST['new_attr_value'];
	$append_context=$_POST['append_context'];
	$new_attr_value_suffix=$_POST['new_attr_value_suffix'];

} else {

	if (@$HTTP_POST_VARS['ldap_id'] > "" ) { 
		
		$working_ou=$HTTP_POST_VARS['working_ou'];
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$cn_to_change="cn=" . $HTTP_POST_VARS['cn_to_change'];
		$attr_to_change=$HTTP_POST_VARS['attr_to_change'];
		$new_attr_value=$HTTP_POST_VARS['new_attr_value'];
		$append_context=$HTTP_POST_VARS['append_context'];
		$new_attr_value_suffix=$HTTP_POST_VARS['new_attr_value_suffix'];
	
	} else {
	
		echo " <h2>DSmobjrun.php must be run from dsmobjedit.php</h2>\n";
		echo "<p>Please select <a href=\"dsmobjedit.php\"> this link to run the DS multiple object editing system.</p>";
		exit;
	}
}

// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection

// So we start by connecting to LDAP

echo "<h1>DS Multiple Edit First Matching Object List</h1>";
echo "<p>Connection to LDAP server";

$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded<br />";
	// we have now made an LDAP connection

} else { 
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	exit;
}

// Search for the (first) entry.
$sr = ldap_search($ds, $working_ou, $cn_to_change, array(cn,$attr_to_change));

echo "<p>Searching in ". $working_ou." for objects named ". $cn_to_change . "</p>";
// Count the number of entries returned and check for errors.

// echo "<p>Search completed, ";

$entry_count = ldap_count_entries($ds, $sr);

// echo $entry_count . " objects found.<br />\n</p>";

if($entry_count >0) {
	echo "<p>Listing the first matching object found</p>\n<p>";	
	$entry = ldap_first_entry($ds, $sr);
	
	// this is a fairly standard PHP page through an array...
	// calling a funxtion to least each one...
	//first one
	write_attr($entry,$ds);
	
	// then the others
	for ($i = 0; $i < $n_entries; $i++){
	   $entry = ldap_next_entry($ds, $entry);
	   write_attr($entry,$ds);
	}
	echo "</p>\n<p>Object Listing End</p>";

} else {
	echo $attr_to_change ;
	echo "<p>No objects were found that match " . $cn_to_change;
	echo " under " . $working_ou ;
	echo ".</p>\n";

}

exit;

function write_attr($entry,$ds){
   $attrs = ldap_get_attributes ($ds, $entry);
   for ($j = 0; $j < $attrs["count"]; $j++){
      $attr_name = $attrs[$j];
      $attrs["$attr_name"]["count"] . "\n";
      for ($k = 0; $k < $attrs["$attr_name"]["count"]; $k++) {
             echo   $attr_name.": ".$attrs["$attr_name"][$k]."<br>\n";
      }
   }
}

?>
</BODY>
</HTML>
